var app = new Vue({
	el : '#logisticsContentDiv',
	data : {
		dispathList : new Array(),
		totalCount : -1,
		query : deepClone(queryCom),
		type : GetUrlParms()["type"],
		SearchDateTime:GetSearchDate(),
		VehicleID:GetUrlParms()["VehicleID"],
		VehicleCode:"",
		orderCode:"",
	},
	filters : {
		CastBasicData : CastBasicData
	},
	methods: {
		search: function(event) {
			app.dispathList = new Array();
			app.totalCount = -1;
			app.query = deepClone(queryCom);
			app.query.PageIndex = 1;
			LodingLogisticsData();
		},
	}
});
function GetSearchDate(){
	if(GetUrlParms()["year"]&&GetUrlParms()["month"]&&GetUrlParms()["day"]){
		return GetUrlParms()["year"]+'-'+GetUrlParms()["month"]+'-'+GetUrlParms()["day"];
	}else{return null;}
}
sysCom.init(function() {
	if(app.VehicleID){
			sysCom.post(urlCom.apiUrl.post_vehicleDetail + "?ID=" + app.VehicleID , //请求地址
					null, //参数
					function(data) {
							if (data.result) {
									app.VehicleCode=data.data.vehicleCode;
							} else {
									sysCom.tips(data.msg);
							}
					},
					function() {
							//錯誤回調
					});
	}
	sysCom.PullUpRefresh(function() {
		LodingLogisticsData();
	});
	sysCom.PullRefresh(function() {
		app.totalCount = -1;
		app.query.PageIndex = 1;
		app.dispathList = new Array();
		LodingLogisticsData();
	});
	LodingLogisticsData();

	sysCom.addEventListener({
		name : 'replay'
	}, function(ret, err) {
		if (ret) {
			replay();
		}
	});
});

function  replay() {
	if(app.VehicleID&&app.VehicleCode){
		var url='vehicle/VehicleTrackReplay.html?ID='+app.VehicleID + '&NumberPlate='+app.VehicleCode;
			if(GetUrlParms()["year"]&&GetUrlParms()["month"]&&GetUrlParms()["day"]){
		  url = url + '&year=' + GetUrlParms()["year"] + '&month=' + GetUrlParms()["month"] + '&day=' + GetUrlParms()["day"];
		}
		debugCom.log("url:"+url);
		openWindow('TrackReplay',url,'轨迹回放');
	}
}

function LodingLogisticsData() {
	if (app.orderCode) { //车牌号
		app.query.Conditions = [{
			Key: "orderCode",
			QueryOperator: "Contains",
			Value: app.orderCode
		}];
	}
	if(app.SearchDateTime){
		if(!app.query.Conditions){app.query.Conditions=[];}
		app.query.Conditions.push({
			Key: "deliveryDate",
			QueryOperator: "DataRange",
			Value: app.SearchDateTime + "|" + app.SearchDateTime+" 23:59:59"
		});
	}
	if(app.VehicleID){
		if(!app.query.Conditions){app.query.Conditions=[];}
		app.query.Conditions.push({
			Key: "vehicleId",
			QueryOperator: "Equals",
			Value: app.VehicleID
		});
	}
	var postUrl=urlCom.apiUrl.post_queryTrackList;
	if(app.type==1){
		postUrl=urlCom.apiUrl.post_queryTrackListMy;
	}
	QueryData(postUrl, app, function(data) {
		app.dispathList = app.dispathList.concat(data.data.Rows);
	});
}
